# Karma Game Library (v1.0.0)

The Karma Game is an efficient, fair, decentralized resource allocation mechanism.

The Karma Game Library is a powerful and rich software framework for the computation of optimal policies for rational agents and the simulation of Karma Games in scientific contexts.
It is easy to use and compatible with domain specific simulators.

**This repository equips you with the necessary tools to successfully apply the Karma mechanism in your resource allocation context.**
In the [documentation](https://derkevinriehl.github.io/karma_game_library/) you will find installation instructions, coding examples in Python and an extensive documentation.

<img src="src/docs/source/_static/logo_light.svg" alt="KarmaKnot" style="width:150px;"/>

Installation
----------------------------------------------
The Karma Game Library can be installed as a Python package using the PIP package manager and the Conda package manager.

**Pip / PyPI Package Manager** ([Link to repository](https://pypi.org/project/karma-game-library/))

```
pip install karma-game-library
```

After installation, you can try one of our [examples](https://derkevinriehl.github.io/karma_game_library/gettingstarted.html) to verify your installation was successful.


What is Karma
----------------------------------------------
Karma employs a resource-inherent, non-tradeable,
artificial currency for prosumer resources in peer-to-peer
markets, meaning that Karma can be gained only
by producing and lost only by consuming resources.

Karma was already applied in many different contexts including computation
resources, telecommunication networks, transportation traffic control on road networks, and social contexts (e.g. food banks, organ donations).

Why Karma
----------------------------------------------

Finding efficient and fair ways of allocating finite,
scarce, infrastructural resources is of crucial importance
for the future social welfare of mankind. Global megatrends
such as global population growth, demographic
change, climate change, urbanization (and smart cities),
mobilization (and autonomous driving), sustainable ecologies
(and renewable energy grids) amongst many more,
cause the competition for important, infrastructural resources
such as healthcare, housing, mobility, nutrition,
and energy, to name a few. The issue of efficient resource
allocation is an interdisciplinary question widely discussed
in many fields ranging from economics, game theory, to
control.

Karma is a remarkable, circumvention-proof, economic
resource allocation mechanism, that offers various attractive
features, such as near-Pareto-efficiency while improving
fairness of resource allocation, privacy enhancement
through incentive incompatibility, stability
through the guaranteed existence of at least one stationary
Nash equilibrium, and robustness to population
heterogeneity such as different temporal preferences and
urgency processes of agents. Last but not least, it
is reported to not only concern the efficiency and fairness
of resource allocation, but also to lead to a decrease
in resource scarcity. Karma employs a resourceinherent,
non-tradeable, artificial currency for prosumer
resources in peer-to-peer markets (peers on the market
both produce and consume), meaning that Karma can
be gained only by producing and lost only by consuming
resources. Thus, it can be classified as a non-monetary
market mechanism, and cannot be circumvented as it is
the case for externalizable, monetary currencies.


About the logo
----------------------------------------------
The logo is a religious symbol called "endless knot", "eternal knot" and represents represents the eternal cycle of life (Samsara).
The endless knot is a symbolic knot and one of the Eight Auspicious Symbols. 
It is an important symbol in Hinduism, Jainism and Buddhism. 
It is an important cultural marker in places significantly influenced by Tibetan Buddhism such as Tibet, Mongolia, Tuva, Kalmykia, and Buryatia. 
It is also found in Celtic, Kazakh and Chinese symbolism. 
[More Information on the logo](https://en.wikipedia.org/wiki/Endless_knot)



Acknowledgements
----------------------------------------------
STILL TO DO

How to cite us
----------------------------------------------

```
Riehl, K., Makridis, M., & You?. (2023). Fair Money - Public Good Value Pricing With Karma Economies
```
